package com.bowlerhatgames.display
{
   import flash.display.Sprite;
   import flash.events.ContextMenuEvent;
   import flash.events.Event;
   import flash.events.KeyboardEvent;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import flash.ui.ContextMenu;
   import flash.ui.ContextMenuItem;
   import flash.ui.Keyboard;
   import net.hires.debug.Stats;
   
   public class GameRoot extends Sprite
   {
      private var _stats:Stats;
      
      public function GameRoot()
      {
         super();
         this.createContextMenuItems();
         this.addEventListener(Event.ADDED_TO_STAGE,addedToStageHandler,false,10000);
      }
      
      protected function playMoreItemSelectHandler(param1:ContextMenuEvent) : void
      {
         navigateToURL(new URLRequest("http://bowlerhatgames.com/"),"_blank");
      }
      
      private function removedFromStageHandler(param1:Event) : void
      {
         if(this._stats)
         {
            this.stage.removeChild(this._stats);
            this._stats = null;
         }
         if(this.loaderInfo.parentAllowsChild)
         {
            this.stage.removeEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
         }
      }
      
      private function addedToStageHandler(param1:Event) : void
      {
         this.removeEventListener(Event.ADDED_TO_STAGE,addedToStageHandler);
         this.createDebugDashboard();
         this.addEventListener(Event.REMOVED_FROM_STAGE,removedFromStageHandler);
      }
      
      private function keyDownHandler(param1:KeyboardEvent) : void
      {
         if(Keyboard.UP == param1.keyCode && param1.altKey && param1.ctrlKey)
         {
            if(this._stats)
            {
               this._stats.visible = !this._stats.visible;
            }
         }
      }
      
      protected function createdByItemSelectHandler(param1:ContextMenuEvent) : void
      {
         navigateToURL(new URLRequest("http://bowlerhatgames.com/"),"_blank");
      }
      
      protected function createDebugDashboard() : void
      {
         if(!this.loaderInfo.parentAllowsChild)
         {
            return;
         }
         this._stats = new Stats();
         this._stats.visible = false;
         this.stage.addChildAt(this._stats,1);
         this.stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler,false,0,true);
      }
      
      protected function createContextMenuItems() : void
      {
         var _loc1_:ContextMenu = new ContextMenu();
         _loc1_.hideBuiltInItems();
         var _loc2_:ContextMenuItem = new ContextMenuItem("Play More Games!",true);
         _loc2_.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,playMoreItemSelectHandler);
         var _loc3_:ContextMenuItem = new ContextMenuItem("Created by Bowler Hat Games");
         _loc3_.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,createdByItemSelectHandler);
         _loc1_.customItems = [_loc2_,_loc3_];
         this.contextMenu = _loc1_;
      }
   }
}

