package com.bowlerhatgames.effects
{
   import com.gskinner.motion.GTween;
   import flash.display.DisplayObject;
   import flash.events.Event;
   import flash.geom.ColorTransform;
   import flash.utils.Dictionary;
   import org.josht.utils.ColorUtil;
   
   public class ColorFlash extends GTween
   {
      private static var ACTIVE_FLASHES:Dictionary = new Dictionary(true);
      
      public function ColorFlash(param1:DisplayObject, param2:uint = 16777215, param3:Number = 1, param4:int = 1, param5:Number = 0.05)
      {
         var _loc10_:ColorFlash = null;
         if(ACTIVE_FLASHES[param1])
         {
            _loc10_ = ACTIVE_FLASHES[param1];
            _loc10_.pause();
            delete ACTIVE_FLASHES[param1];
         }
         ACTIVE_FLASHES[param1] = this;
         param1.transform.colorTransform = new ColorTransform();
         param3 = Math.max(Math.min(param3,1),0);
         var _loc6_:Number = 1 - param3;
         var _loc7_:uint = ColorUtil.red(param2) * param3;
         var _loc8_:uint = ColorUtil.green(param2) * param3;
         var _loc9_:uint = ColorUtil.blue(param2) * param3;
         super(param1,param5,{
            "redMultiplier":_loc6_,
            "greenMultiplier":_loc6_,
            "blueMultiplier":_loc6_,
            "redOffset":_loc7_,
            "greenOffset":_loc8_,
            "blueOffset":_loc9_
         },{
            "repeat":param4 * 2 - 1,
            "reflect":true,
            "assignmentTarget":param1.transform,
            "assignmentProperty":"colorTransform",
            "completeListener":colorFlashCompleteHandler
         });
      }
      
      private function colorFlashCompleteHandler(param1:Event) : void
      {
         param1.currentTarget.removeEventListener(param1.type,arguments.callee);
         if(ACTIVE_FLASHES[this.target] == this)
         {
            delete ACTIVE_FLASHES[this.target];
         }
      }
   }
}

