package com.bowlerhatgames.gridshock
{
   import com.gskinner.motion.GTween;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.display.StageAlign;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import flash.utils.getTimer;
   import flash.utils.setTimeout;
   
   public class Preloader extends MovieClip
   {
      private static const ROOT_CLASS:String = "Gridshock";
      
      private static const MINIMUM_AD_TIME:int = 5000;
      
      public var fadeIn:GTween;
      
      public var splashScreen:Sprite;
      
      public var sponsorAd:Sprite;
      
      public function Preloader()
      {
         addFrameScript(1,frame2,2,frame3);
         super();
         stop();
         if(this.stage)
         {
            this.stage.align = StageAlign.TOP_LEFT;
         }
         this.loaderInfo.addEventListener(Event.INIT,swfInitHandler);
      }
      
      internal function frame2() : *
      {
         fadeIn = new GTween(this.splashScreen,0.25,{"alpha":1});
         fadeIn.addEventListener(Event.COMPLETE,fadeInCompleteListener);
      }
      
      public function instructionsCompleteHandler(param1:Event) : void
      {
         if(param1.target is FrosmoSponsorButton)
         {
            navigateToURL(new URLRequest("http://www.frosmo.com/uk/ui/?ref=gridlock"),"_blank");
            return;
         }
         this.stage.removeEventListener(MouseEvent.CLICK,instructionsCompleteHandler);
         gotoAndStop(currentFrame + 1);
      }
      
      internal function frame3() : *
      {
         this.stage.addEventListener(MouseEvent.CLICK,instructionsCompleteHandler,false,0,true);
      }
      
      public function fadeInCompleteListener(param1:Event) : void
      {
         param1.currentTarget.removeEventListener(param1.type,arguments.callee);
         setTimeout(timerComplete,1750);
      }
      
      private function enterFrameHandler(param1:Event) : void
      {
         var _loc2_:Number = this.loaderInfo.bytesLoaded / this.loaderInfo.bytesTotal;
         _loc2_ = Math.min(_loc2_,getTimer() / MINIMUM_AD_TIME);
         if(_loc2_ >= 1)
         {
            this.loadGame();
            return;
         }
         var _loc3_:Number = 30;
         var _loc4_:Number = 25;
         this.graphics.clear();
         this.graphics.beginFill(8960768);
         this.graphics.drawRect(_loc3_,this.loaderInfo.height - _loc4_ - 20,this.loaderInfo.width - 2 * _loc3_,_loc4_);
         this.graphics.endFill();
         this.graphics.beginFill(0);
         this.graphics.drawRect(_loc3_ + 2,this.loaderInfo.height - (_loc4_ - 2) - 20,this.loaderInfo.width - 2 * _loc3_ - 4,_loc4_ - 4);
         this.graphics.endFill();
         this.graphics.beginFill(8978176);
         this.graphics.drawRect(_loc3_ + 5,this.loaderInfo.height - (_loc4_ - 5) - 20,_loc2_ * (this.loaderInfo.width - 2 * _loc3_ - 10),_loc4_ - 10);
         this.graphics.endFill();
      }
      
      private function sponsorAdClickHandler(param1:MouseEvent) : void
      {
         navigateToURL(new URLRequest("http://www.frosmo.com/uk/ui/?ref=gridlock"),"_blank");
      }
      
      private function loadGame() : void
      {
         this.removeEventListener(Event.ENTER_FRAME,enterFrameHandler);
         this.removeChild(this.sponsorAd);
         this.sponsorAd.removeEventListener(MouseEvent.CLICK,sponsorAdClickHandler);
         this.sponsorAd = null;
         this.graphics.clear();
         this.gotoAndStop(2);
      }
      
      public function timerComplete() : void
      {
         new GTween(this.splashScreen,0.15,{"alpha":0});
         this.gotoAndStop(currentFrame + 1);
      }
      
      private function swfInitHandler(param1:Event) : void
      {
         param1.currentTarget.removeEventListener(Event.INIT,swfInitHandler);
         this.sponsorAd.buttonMode = true;
         this.sponsorAd.addEventListener(MouseEvent.CLICK,sponsorAdClickHandler);
         this.addEventListener(Event.ENTER_FRAME,enterFrameHandler);
      }
   }
}

